<id>
Recent posts user preference
</id>

<version>
1.0
</version>

<mod info>
Per user customization of recent forum posts
</mod info>

<author>
miseryshining
</author>

<homepage>
http://simplemachines.org
</homepage>

<edit file>
/Themes/default/languages/Profile.english.php
</edit file>
<search for>
$txt['no_buddies'] = 'Your buddy list is currently empty';
</search for>
<add after>

$txt['RP_title'] = 'Recent posts settings';
$txt['RP_info'] = 'Here you can setup preferences for the recent post box.';
$txt['RP_blockSettings'] = 'Settings for blocks';
$txt['RP_lastOnly'] = 'Topic view (Only show the last reply of a thread)';
$txt['RP_nrofPosts'] = 'Number of posts to show';
$txt['RP_recentPosts'] = $txt['recentPosts'] = 'Recent posts preferences';
$txt['RP_listheader'] = 'check the boards you want to monitor';
</add after>

<edit file>
/Themes/default/languages/ManageSettings.english.php
</edit file>
<search for>
$txt['pollMode']
</search for>
<add before>
$txt['recentposts_title'] = 'Recent posts & topics';
$txt['recentpostsExtraprefs'] = 'Enable extra user preferences for recent post blocks';
$txt['recentpostsLimitdays'] = 'Timeframe in which to search for recent posts/topics (in days)';
$txt['recentpostsNrofposts'] = 'Number of posts to show in blocks by default';
$txt['recentpostsMode'] = 'Use recent topics mode (instead of posts) on board index';
$helptxt['recentpostsMode'] = 'Will show recent topics instead of posts for members that haven\'t set up their preferences and for guests.';

</add before>


<edit file>
/Themes/default/languages/Admin.english.php
</edit file>

<search for>
$txt['mods_cat_modifications_misc'] = 'Miscellaneous';
</search for>
<add after>
$txt['mods_cat_recentposts'] = 'Recent posts/topics';
</add after>


<edit file>
/Themes/default/languages/index.english.php
</edit file>
<search for>
$txt['unread_topics_visit'] 
</search for>
<add before>
$txt['recent_topics'] = 'Recent topics';
$txt['unread_topics_only'] = 'show unread only';
$txt['RP_topics_visit_none'] = 'No recent topics found.';
</add before>

<edit file>
/Sources/Load.php
</edit file>

<search for>
	// Set up the $user_info array.
	$user_info += array(
</search for>
<add after>
		'recentPosts' => array('boards' => (!empty($user_settings['recentpost_boards']) ? explode(',',$user_settings['recentpost_boards']) : array()), 'lastOnly' => (!empty($user_settings['recent_last_only']) ? $user_settings['recent_last_only'] : null), 'nrofPosts' => (!empty($user_settings['recent_nrof_posts']) ? $user_settings['recent_nrof_posts']  : null)),
</add after>

<search for>
	// Set up the contextual user array.
	$context['user'] = array(
</search for>
<add after>
		'recentPosts' => &$user_info['recentPosts'],
</add after>

<edit file>
/SSI.php
</edit file>

<search for>
// Recent post list:   [board] Subject by Poster	Date
function ssi_recentPosts($num_recent = 8, $exclude_boards = null, $include_boards = null, $output_method = 'echo')
</search for>
<replace>
// Recent posts & topics user preference
function ssi_recentPostsPref($nrofPosts=null, $boards=null, $returnMode='echo', $mode=null, $limit_days=null, $member_id = null)
{
	global $context, $user_info, $modSettings, $settings;
	if ($user_info['is_guest']) {
		if ($modSettings['recentpostsExtraprefs'] == 1)
			$context['user']['recentPosts']['lastOnly'] = 2;
		else 
			$context['user']['recentPosts']['lastOnly'] = 1;
		$context['user']['recentPosts']['boards'] = '';
	}
	
	if ($nrofPosts == null) {
		if ($modSettings['recentpostsExtraprefs'] == 1 && isset($context['user']['recentPosts']['nrofPosts'])) //user setting 
			$nrofPosts = $context['user']['recentPosts']['nrofPosts'];
		elseif (isset($modSettings['recentpostsNrofposts']) && $modSettings['recentpostsNrofposts'] != 0) //global setting
			$nrofPosts = $modSettings['recentpostsNrofposts'];
		elseif (isset($settings['number_recent_posts']) && $settings['number_recent_posts'] != 0) //theme setting
			$nrofPosts = $settings['number_recent_posts'];
		else $nrofPosts = 10;
	}
	
	if ($limit_days == null && isset($modSettings['recentpostsLimitdays']) && $modSettings['recentpostsLimitdays'] != 0)
		$limit_days = $modSettings['recentpostsLimitdays'];
	
	if ($boards === null && !empty($context['user']['recentPosts']['boards'])) 
		$boards = $context['user']['recentPosts']['boards'];
	elseif ($boards == 'all') 
		$boards = null;

	if ($mode == null) { 
		if (isset($context['user']['recentPosts']['lastOnly']) && $modSettings['recentpostsExtraprefs'] == 1) {
			if ($context['user']['recentPosts']['lastOnly'] == 2) { //topics only
				return ssi_recentTopics($nrofPosts, null, $returnMode, $boards, $limit_days, $member_id);
			}
			else { //posts only
				if ($returnMode == 'extended') $returnMode = 'echo';
				return ssi_recentPosts($nrofPosts, null, $returnMode, $boards, $limit_days, $member_id);
			}
		}
		elseif (isset($modSettings['recentpostsMode']) && $modSettings['recentpostsMode'] != 0) {
			return ssi_recentTopics($nrofPosts, null, $returnMode, $boards, $limit_days, $member_id);
		}
		else {
			if ($returnMode == 'extended') $returnMode = 'echo';
			return ssi_recentPosts($nrofPosts, null, $returnMode, $boards, $limit_days, $member_id);
		}
	}
}

// Recent post list:   [board] Subject by Poster	Date
function ssi_recentPosts($num_recent = 8, $exclude_boards = null, $output_method = 'echo', $include_boards = null, $limit_days = null, $member_id = null)
</replace>

<search for>
	// Let's restrict the query boys (and girls)
	$query_where = '
		m.id_msg >= {int:min_message_id}
		' . (empty($exclude_boards) ? '' : '
		AND b.id_board NOT IN ({array_int:exclude_boards})') . '
		' . ($include_boards === null ? '' : '
		AND b.id_board IN ({array_int:include_boards})') . '
		AND {query_wanna_see_board}' . ($modSettings['postmod_active'] ? '
		AND m.approved = {int:is_approved}' : '');

	$query_where_params = array(
		'is_approved' => 1,
		'include_boards' => $include_boards === null ? '' : $include_boards,
		'exclude_boards' => empty($exclude_boards) ? '' : $exclude_boards,
		'min_message_id' => $modSettings['maxMsgID'] - 25 * min($num_recent, 5),
	);
</search for>
<replace>
	// Let's restrict the query boys (and girls)
	$query_where = '
		m.id_msg >= {int:min_message_id}
		' . (empty($exclude_boards) ? '' : '
		AND b.id_board NOT IN ({array_int:exclude_boards})') . '
		' . ($include_boards === null ? '' : '
		AND b.id_board IN ({array_int:include_boards})') . '
		' . (empty($limit_days) ? '' : '
		AND m.poster_time > ' . (time() - ($limit_days*24*60*60))) . '
		' . (empty($member_id) ? '' : '
		AND m.id_member = {$member_id}') . '
		AND {query_wanna_see_board}' . ($modSettings['postmod_active'] ? '
		AND m.approved = {int:is_approved}' : '');

	$query_where_params = array(
		'is_approved' => 1,
		'include_boards' => $include_boards === null ? '' : $include_boards,
		'exclude_boards' => empty($exclude_boards) ? '' : $exclude_boards,
		'min_message_id' => isset($limit_days) ? '0' : $modSettings['maxMsgID'] - 25 * min($num_recent, 5),
	);
</replace>

<search for>
			'href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . '#msg' . $row['id_msg'] . '" rel="nofollow">' . $row['subject'] . '</a>',
</search for>
<add before>
			'raw_timestamp' => $row['poster_time'],
</add before>

<search for>
function ssi_recentTopics($num_recent = 8, $exclude_boards = null, $include_boards = null, $output_method = 'echo')
</search for>
<replace>
function ssi_recentTopics($num_recent = 8, $exclude_boards = null, $output_method = 'echo', $include_boards = null, $limit_days = null, $member_id = null)
</replace>

<search for>
	// Find all the posts in distinct topics.  Newer ones will have higher IDs.
	$request = $smcFunc['db_query']('substring', '
		SELECT
			m.poster_time, ms.subject, m.id_topic, m.id_member, m.id_msg, b.id_board, b.name AS board_name, t.num_replies, t.num_views,
			IFNULL(mem.real_name, m.poster_name) AS poster_name, ' . ($user_info['is_guest'] ? '1 AS is_read, 0 AS new_from' : '
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, 0)) >= m.id_msg_modified AS is_read,
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, -1)) + 1 AS new_from') . ', SUBSTRING(m.body, 1, 384) AS body, m.smileys_enabled, m.icon
		FROM {db_prefix}topics AS t
			INNER JOIN {db_prefix}messages AS m ON (m.id_msg = t.id_last_msg)
			INNER JOIN {db_prefix}boards AS b ON (b.id_board = t.id_board)
			INNER JOIN {db_prefix}messages AS ms ON (ms.id_msg = t.id_first_msg)
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)' . (!$user_info['is_guest'] ? '
			LEFT JOIN {db_prefix}log_topics AS lt ON (lt.id_topic = t.id_topic AND lt.id_member = {int:current_member})
			LEFT JOIN {db_prefix}log_mark_read AS lmr ON (lmr.id_board = b.id_board AND lmr.id_member = {int:current_member})' : '') . '
		WHERE t.id_last_msg >= {int:min_message_id}
			' . (empty($exclude_boards) ? '' : '
			AND b.id_board NOT IN ({array_int:exclude_boards})') . '
			' . (empty($include_boards) ? '' : '
			AND b.id_board IN ({array_int:include_boards})') . '
			AND {query_wanna_see_board}' . ($modSettings['postmod_active'] ? '
			AND t.approved = {int:is_approved}
			AND m.approved = {int:is_approved}' : '') . '
		ORDER BY t.id_last_msg DESC
		LIMIT ' . $num_recent,
		array(
			'current_member' => $user_info['id'],
			'include_boards' => empty($include_boards) ? '' : $include_boards,
			'exclude_boards' => empty($exclude_boards) ? '' : $exclude_boards,
			'min_message_id' => $modSettings['maxMsgID'] - 35 * min($num_recent, 5),
			'is_approved' => 1,
		)
	);
</search for>
<replace>
	// Find all the posts in distinct topics.  Newer ones will have higher IDs.

	$extravalues = '';
	if ($output_method == 'extended') {
		// get all the extra information about topics, so we can send them to Recent.template.php later
		$extravalues =	'
				ms.subject AS first_subject, ms.poster_time AS first_poster_time, ms.id_topic, t.id_board, b.name AS bname,
				t.num_replies, t.num_views, ms.id_member AS id_first_member, m.id_member AS id_last_member,
				m.poster_time AS last_poster_time, memfp.real_name AS first_poster_name,
				mem.real_name AS last_poster_name, m.subject AS last_subject,
				m.icon AS last_icon, ms.icon AS first_icon, t.id_poll, t.is_sticky, t.locked, m.modified_time AS last_modified_time,
				' . (!$user_info['is_guest'] ? ' 
				IFNULL(lt.id_msg, IFNULL(lmr.id_msg, -1)) + 1 AS new_from,' : '') .' SUBSTRING(m.body, 1, 385) AS last_body,
				SUBSTRING(ms.body, 1, 385) AS first_body, m.smileys_enabled AS last_smileys, ms.smileys_enabled AS first_smileys, t.id_first_msg, t.id_last_msg, ';
	}
	
	$request = $smcFunc['db_query']('', '
		SELECT 
			'. $extravalues .'
			m.poster_time, ms.subject, m.id_topic, m.id_member, m.id_msg, b.id_board, b.name AS board_name, t.num_replies, t.num_views,
			IFNULL(mem.real_name, m.poster_name) AS poster_name, ' . ($user_info['is_guest'] ? '1 AS is_read, 0 AS new_from' : '
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, 0)) >= m.id_msg_modified AS is_read,
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, -1)) + 1 AS new_from') . ', SUBSTRING(m.body, 1, 384) AS body, m.smileys_enabled, m.icon
		FROM {db_prefix}topics AS t
			INNER JOIN {db_prefix}messages AS m ON (m.id_msg = t.id_last_msg)
			INNER JOIN {db_prefix}boards AS b ON (b.id_board = t.id_board)
			INNER JOIN {db_prefix}messages AS ms ON (ms.id_msg = t.id_first_msg)
			LEFT JOIN {db_prefix}members AS memfp ON (memfp.id_member = ms.id_member)
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)' . (!$user_info['is_guest'] ? '
			LEFT JOIN {db_prefix}log_topics AS lt ON (lt.id_topic = t.id_topic AND lt.id_member = {int:current_member})
			LEFT JOIN {db_prefix}log_mark_read AS lmr ON (lmr.id_board = b.id_board AND lmr.id_member = {int:current_member})' : '') . '
		WHERE t.id_last_msg >= {int:min_message_id}
			AND t.ID_LAST_MSG = m.id_msg		
			' . (empty($exclude_boards) ? '' : '
			AND b.id_board NOT IN ({array_int:exclude_boards})') . '
			' . (empty($include_boards) ? '' : '
			AND b.id_board IN ({array_int:include_boards})') . '
			' . (empty($limit_days) ? '' : '
			AND m.poster_time > ' . (time() - ($limit_days*24*60*60))) . '
			' . (empty($member_id) ? '' : '
			AND m.id_member = {$member_id}') . '
			AND {query_wanna_see_board}' . ($modSettings['postmod_active'] ? '
			AND t.approved = {int:is_approved}
			AND m.approved = {int:is_approved}' : '') . '
			AND ms.id_msg = t.id_first_msg
		ORDER BY ' . ($output_method == 'extended' && isset($_REQUEST['sort']) ? (
			$_REQUEST['sort'] . ($context['ascending'] ? '' : ' DESC')) : ("t.id_last_msg DESC")) . "
		LIMIT " . (($output_method == 'extended' && isset($_REQUEST['start']) && isset($_REQUEST['action']) && $_REQUEST['action'] == 'recenttopics' && is_numeric($_REQUEST['start'])) ? ($_REQUEST['start'].', ') : ('')) . $num_recent,
		array(
			'current_member' => $user_info['id'],
			'include_boards' => empty($include_boards) ? '' : $include_boards,
			'exclude_boards' => empty($exclude_boards) ? '' : $exclude_boards,
			'min_message_id' => isset($limit_days) ? '0' : $modSettings['maxMsgID'] - 35 * min($num_recent, 5),
			'is_approved' => 1,
		)
	);
</replace>

<search for>
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileys_enabled'], $row['id_msg']), array('<br />' => '&#10;')));
		if ($smcFunc['strlen']($row['body']) > 128)
			$row['body'] = $smcFunc['substr']($row['body'], 0, 128) . '...';

		// Censor the subject.
		censorText($row['subject']);
		censorText($row['body']);

		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		// Build the array.
		$posts[] = array(
			'board' => array(
				'id' => $row['id_board'],
				'name' => $row['board_name'],
				'href' => $scripturl . '?board=' . $row['id_board'] . '.0',
				'link' => '<a href="' . $scripturl . '?board=' . $row['id_board'] . '.0">' . $row['board_name'] . '</a>'
			),
			'topic' => $row['id_topic'],
			'poster' => array(
				'id' => $row['id_member'],
				'name' => $row['poster_name'],
				'href' => empty($row['id_member']) ? '' : $scripturl . '?action=profile;u=' . $row['id_member'],
				'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>'
			),
			'subject' => $row['subject'],
			'replies' => $row['num_replies'],
			'views' => $row['num_views'],
			'short_subject' => shorten_subject($row['subject'], 25),
			'preview' => $row['body'],
			'time' => timeformat($row['poster_time']),
			'timestamp' => forum_time(true, $row['poster_time']),
			'href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . '#new" rel="nofollow">' . $row['subject'] . '</a>',
			// Retained for compatibility - is technically incorrect!
			'new' => !empty($row['is_read']),
			'is_new' => empty($row['is_read']),
			'new_from' => $row['new_from'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
		);
	}
</search for>
<replace>
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		// this puts the extended topic information into $context['topics']. it's copied from Recent.php and can be used by template_unread() in Recent.template.php
		if ($output_method == 'extended') { 
			//set these variables so there will be no undefined indexes
			$context['querystring_board_limits'] = '';
			$context['sort_by'] = '';
			
			if ($row['id_poll'] > 0 && $modSettings['pollMode'] == '0')
				continue;
	
			$topic_ids[] = $row['id_topic'];
	
			// Clip the strings first because censoring is slow :/. (for some reason?)
			$row['first_body'] = strip_tags(strtr(parse_bbc($row['first_body'], $row['first_smileys'], $row['id_first_msg']), array('<br />' => '&#10;')));
			if ($smcFunc['strlen']($row['first_body']) > 128)
				$row['first_body'] = $smcFunc['substr']($row['first_body'], 0, 128) . '...';
			$row['last_body'] = strip_tags(strtr(parse_bbc($row['last_body'], $row['last_smileys'], $row['id_last_msg']), array('<br />' => '&#10;')));
			if ($smcFunc['strlen']($row['last_body']) > 128)
				$row['last_body'] = $smcFunc['substr']($row['last_body'], 0, 128) . '...';
	
			// Do a bit of censoring...
			censorText($row['first_subject']);
			censorText($row['first_body']);
	
			// But don't do it twice, it can be a slow ordeal!
			if ($row['id_first_msg'] == $row['id_last_msg'])
			{
				$row['last_subject'] = $row['first_subject'];
				$row['last_body'] = $row['first_body'];
			}
			else
			{
				censorText($row['last_subject']);
				censorText($row['last_body']);
			}
	
			// Decide how many pages the topic should have.
			$topic_length = $row['num_replies'] + 1;
			$messages_per_page = empty($modSettings['disableCustomPerPage']) && !empty($options['messages_per_page']) && !WIRELESS ? $options['messages_per_page'] : $modSettings['defaultMaxMessages'];
			if ($topic_length > $messages_per_page)
			{
				$tmppages = array();
				$tmpa = 1;
				for ($tmpb = 0; $tmpb < $topic_length; $tmpb += $messages_per_page)
				{
					$tmppages[] = '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.' . $tmpb . ';topicseen">' . $tmpa . '</a>';
					$tmpa++;
				}
				// Show links to all the pages?
				if (count($tmppages) <= 5)
					$pages = '&#171; ' . implode(' ', $tmppages);
				// Or skip a few?
				else
					$pages = '&#171; ' . $tmppages[0] . ' ' . $tmppages[1] . ' ... ' . $tmppages[count($tmppages) - 2] . ' ' . $tmppages[count($tmppages) - 1];
	
				if (!empty($modSettings['enableAllMessages']) && $topic_length < $modSettings['enableAllMessages'])
					$pages .= ' &nbsp;<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0;all">' . $txt['all'] . '</a>';
				$pages .= ' &#187;';
			}
			else
				$pages = '';
	
			// We need to check the topic icons exist... you can never be too sure!
			if (empty($modSettings['messageIconChecks_disable']))
			{
				// First icon first... as you'd expect.
				if (!isset($context['icon_sources'][$row['first_icon']]))
					$context['icon_sources'][$row['first_icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['first_icon'] . '.gif') ? 'images_url' : 'default_images_url';
				// Last icon... last... duh.
				if (!isset($context['icon_sources'][$row['last_icon']]))
					$context['icon_sources'][$row['last_icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['last_icon'] . '.gif') ? 'images_url' : 'default_images_url';
			}
	
			// And build the array.
			$context['topics'][$row['id_topic']] = array(
				'id' => $row['id_topic'],
				'first_post' => array(
					'id' => $row['id_first_msg'],
					'member' => array(
						'name' => $row['first_poster_name'],
						'id' => $row['id_first_member'],
						'href' => $scripturl . '?action=profile;u=' . $row['id_first_member'],
						'link' => !empty($row['id_first_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_first_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_poster_name'] . '">' . $row['first_poster_name'] . '</a>' : $row['first_poster_name']
					),
					'time' => timeformat($row['first_poster_time']),
					'timestamp' => forum_time(true, $row['first_poster_time']),
					'subject' => $row['first_subject'],
					'preview' => $row['first_body'],
					'icon' => $row['first_icon'],
					'icon_url' => $settings[$context['icon_sources'][$row['first_icon']]] . '/post/' . $row['first_icon'] . '.gif',
					'href' => $scripturl . '?topic=' . $row['id_topic'] . '.0;topicseen',
					'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0;topicseen">' . $row['first_subject'] . '</a>'
				),
				'last_post' => array(
					'id' => $row['id_last_msg'],
					'member' => array(
						'name' => $row['last_poster_name'],
						'id' => $row['id_last_member'],
						'href' => $scripturl . '?action=profile;u=' . $row['id_last_member'],
						'link' => !empty($row['id_last_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_last_member'] . '">' . $row['last_poster_name'] . '</a>' : $row['last_poster_name']
					),
					'time' => timeformat($row['last_poster_time']),
					'timestamp' => forum_time(true, $row['last_poster_time']),
					'subject' => $row['last_subject'],
					'preview' => $row['last_body'],
					'icon' => $row['last_icon'],
					'icon_url' => $settings[$context['icon_sources'][$row['last_icon']]] . '/post/' . $row['last_icon'] . '.gif',
					'href' => $scripturl . '?topic=' . $row['id_topic'] . ($row['num_replies'] == 0 ? '.0' : '.msg' . $row['id_last_msg']) . ';topicseen#msg' . $row['id_last_msg'],
					'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . ($row['num_replies'] == 0 ? '.0' : '.msg' . $row['id_last_msg']) . ';topicseen#msg' . $row['id_last_msg'] . '" rel="nofollow">' . $row['last_subject'] . '</a>'
				),
				'new_from' => $row['new_from'],
				'new_href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['new_from'] . ';topicseen#new',
				'href' => $scripturl . '?topic=' . $row['id_topic'] . ($row['num_replies'] == 0 ? '.0' : '.msg' . $row['new_from']) . ';topicseen' . ($row['num_replies'] == 0 ? '' : 'new'),
				'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . ($row['num_replies'] == 0 ? '.0' : '.msg' . $row['new_from']) . ';topicseen#msg' . $row['new_from'] . '" rel="nofollow">' . $row['first_subject'] . '</a>',
				'is_new' => empty($row['is_read']),
				'is_sticky' => !empty($modSettings['enableStickyTopics']) && !empty($row['is_sticky']),
				'is_locked' => !empty($row['locked']),
				'is_poll' => $modSettings['pollMode'] == '1' && $row['id_poll'] > 0,
				'is_hot' => $row['num_replies'] >= $modSettings['hotTopicPosts'],
				'is_very_hot' => $row['num_replies'] >= $modSettings['hotTopicVeryPosts'],
				'is_posted_in' => false,
				'icon' => $row['first_icon'],
				'icon_url' => $settings[$context['icon_sources'][$row['first_icon']]] . '/post/' . $row['first_icon'] . '.gif',
				'subject' => $row['first_subject'],
				'pages' => $pages,
				'replies' => $row['num_replies'],
				'views' => $row['num_views'],
				'board' => array(
					'id' => $row['id_board'],
					'name' => $row['bname'],
					'href' => $scripturl . '?board=' . $row['id_board'] . '.0',
					'link' => '<a href="' . $scripturl . '?board=' . $row['id_board'] . '.0">' . $row['bname'] . '</a>'
				)
			);
	
			determineTopicClass($context['topics'][$row['id_topic']]);
		}
		else {
			$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileys_enabled'], $row['id_msg']), array('<br />' => '&#10;')));
			if ($smcFunc['strlen']($row['body']) > 128)
				$row['body'] = $smcFunc['substr']($row['body'], 0, 128) . '...';
	
			// Censor the subject.
			censorText($row['subject']);
			censorText($row['body']);
	
			if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
				$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';
	
			// Build the array.
			$posts[] = array(
				'board' => array(
					'id' => $row['id_board'],
					'name' => $row['board_name'],
					'href' => $scripturl . '?board=' . $row['id_board'] . '.0',
					'link' => '<a href="' . $scripturl . '?board=' . $row['id_board'] . '.0">' . $row['board_name'] . '</a>'
				),
				'topic' => $row['id_topic'],
				'poster' => array(
					'id' => $row['id_member'],
					'name' => $row['poster_name'],
					'href' => empty($row['id_member']) ? '' : $scripturl . '?action=profile;u=' . $row['id_member'],
					'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>'
				),
				'subject' => $row['subject'],
				'replies' => $row['num_replies'],
				'views' => $row['num_views'],
				'short_subject' => shorten_subject($row['subject'], 25),
				'preview' => $row['body'],
				'time' => timeformat($row['poster_time']),
				'timestamp' => forum_time(true, $row['poster_time']),
				'href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . ';topicseen#new',
				'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . '#new" rel="nofollow">' . $row['subject'] . '</a>',
				// Retained for compatibility - is technically incorrect!
				'new' => !empty($row['is_read']),
				'is_new' => empty($row['is_read']),
				'new_from' => $row['new_from'],
				'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
			);
		}
	}
</replace>


<edit file>
/Sources/Profile.php
</edit file>

<search for>
				'theme' => array(
					'label' => $txt['theme'],
					'file' => 'Profile-Modify.php',
					'function' => 'theme',
					'sc' => 'post',
					'permission' => array(
						'own' => array('profile_extra_any', 'profile_extra_own'),
						'any' => array('profile_extra_any'),
					),
				),
</search for>
<add after>
				'recentPosts' => array(
					'label' => $txt['RP_recentPosts'],
					'file' => 'Profile-Modify.php',
					'function' => 'recentPosts',
					'sc' => 'post',
					'permission' => array(
    					'own' => array('profile_extra_any', 'profile_extra_own'),
	    				'any' => array('profile_extra_any'),
					),
				),
</add after>

<search for>
		elseif (isset($_REQUEST['area']) && in_array($_REQUEST['area'], array('account', 'forumprofile', 'theme', 'pmprefs')))
			saveProfileFields();
</search for>
<add after>
		elseif (isset($_REQUEST['area']) && $_REQUEST['area'] == 'recentPosts')
			makeRecentPostsChanges($memID);
</add after>


<edit file>
/Sources/Profile-Modify.php
</edit file>

<search for>
// Make any notification changes that need to be made.
function makeNotificationChanges($memID)
</search for>
<add before>
// Make any recent board changes that are sent with the profile..
function makeRecentPostsChanges($memID)
{
	global $smcFunc, $db_prefix, $modSettings;

	//recent posts settings are changed
    $boardRecentStr = isset($_POST['boardRecent']) ? implode(',', $_POST['boardRecent']) : 0;
    if (isset($_POST['lastOnly']))
        $recent_last_only = 2; 
    else $recent_last_only = 1;
    if (empty($_POST['nrofPosts'])) $_POST['nrofPosts'] = 10;

    $nrOfPosts = (int) $_POST['nrofPosts'];
    $smcFunc['db_query']('', "
        UPDATE {db_prefix}members 
        SET recentpost_boards = '{$boardRecentStr}',
        recent_last_only = $recent_last_only,
        recent_nrof_posts = {$nrOfPosts}
        WHERE id_member = {$memID} LIMIT 1");
}

</add before>

<search for>
// Display the notifications and settings for changes.
function notification($memID)
</search for>
<add before>
function recentPosts($memID)
{
	global $smcFunc, $txt, $context, $user_profile, $db_prefix, $modSettings, $settings, $user_info;

	//select user preference if $memID != user ID. 
	if ($user_info['id'] != $memID) {
		$result = $smcFunc['db_query']('', "SELECT recentpost_boards, recent_last_only, recent_nrof_posts FROM {$db_prefix}members WHERE id_member = {$memID} LIMIT 1");
		$row = $smcFunc['db_fetch_assoc']($result);
		$context['user']['recentPosts']['boards'] = !empty($row['recentpost_boards']) ? explode(',',$row['recentpost_boards']) : array();
		$context['user']['recentPosts']['lastOnly'] = $row['recent_last_only'];
		$context['user']['recentPosts']['nrofPosts'] = !empty($row['recent_nrof_posts']) ? $row['recent_nrof_posts'] : "10";
	}

	$recentpost_boards = $context['user']['recentPosts']['boards'];

	$result = $smcFunc['db_query']('', "
		SELECT id_group, group_name
		FROM {$db_prefix}membergroups
		WHERE (id_group > 3 OR id_group = 2)" . (empty($modSettings['permission_enable_postgroups']) ? "
			AND min_posts = -1" : '') . "
		ORDER BY min_posts, id_group != 2, group_name");
	$context['groups'] = array();
	while ($row = mysql_fetch_assoc($result))
		$context['groups'][] = array(
			'id' => $row['id_group'],
			'name' => $row['group_name']
		);
	$smcFunc['db_free_result']($result);

	$result_boards = $smcFunc['db_query']('', "
		SELECT
			b.id_board, b.name AS board_name, b.child_level, b.description,
			b.num_posts, b.num_topics, b.id_parent
		FROM {$db_prefix}boards AS b
		WHERE $user_info[query_see_board]" . (empty($modSettings['countChildPosts']) ? "
			AND b.child_Level <= 1" : ''));

		$context['boards'] = array();
		while ($row = mysql_fetch_assoc($result_boards))
		$context['boards'][] = array(
			'id' => $row['id_board'],
			'name' => $row['board_name'],
			'child_level' => $row['child_level'],
			'selected' => false,
			'monitor' => (in_array($row['id_board'],$recentpost_boards)) ? 1 : -1
		);
		$smcFunc['db_free_result']($result_boards);

	loadThemeOptions($memID);

	loadLanguage('Settings');
}

</add before>


<edit file>
/Themes/default/Profile.template.php
</edit file>

<search for>
function template_notification()
</search for>
<add before>
// Template for showing recent posts settings.
function template_recentPosts()
{
	global $context, $settings, $options, $scripturl, $modSettings, $txt, $user_info;
	
	if (!empty($context['boards']))
	{
		echo '
			<table border="0" width="85%" cellspacing="1" cellpadding="4" align="center" class="bordercolor">
				<tr class="titlebg">
					<td height="26">
						&nbsp;<img src="', $settings['images_url'], '/icons/profile_sm.gif" alt="" border="0" align="top" />&nbsp;
						' . $txt['RP_title'] . '
					</td>
				</tr><tr class="windowbg">
					<td class="smalltext" height="25" style="padding: 2ex;">
						' . $txt['RP_info'] . '
					</td>
				</tr><tr>
				<td class="windowbg2" style="padding-bottom: 2ex;">
				<form action="', $scripturl, '?action=profile;area=recentPosts;save" method="post" accept-charset="', $context['character_set'], '" style="margin: 0;">
				<table border="0" width="100%" cellpadding="3">
				  	<tr class="windowbg2">
					<td valign="top">
						<fieldset>
						<legend>',$txt['RP_listheader'],'</legend>';
						foreach ($context['boards'] as $board) {
							echo '<div style="margin-left: ', $board['child_level'], 'em;"><input type="checkbox" name="boardRecent[]" id="boardaccess_', $board['id'], '" value="', $board['id'], '" ', $board['monitor'] == 1 ? ' checked="checked"' : '', ' class="check" /> <label for="boardaccess_', $board['id'], '">', $board['name'], '</label></div>';
						}

		echo '<br />
							<input type="checkbox" id="checkall_check" class="check" onclick="invertAll(this, this.form, \'boardRecent\');" /> <label for="checkall_check"><i>', $txt['check_all'], '</i></label>
						</fieldset>
					</td>
				</tr></table>';
				if ($modSettings['recentpostsExtraprefs'] == 1) { 					
		echo '			<table class="bordercolor" width="100%" cellspacing="1" cellpadding="4" border="0" style="margin-top: 10px;">
					<tr>
					<td class="catbg" width="100%">',$txt['RP_blockSettings'],'</td>
					</tr>
					<tr class="windowbg2">
					<td valign="top"><input type="checkbox" class="check" name="lastOnly" id="lastOnly" ', $context['user']['recentPosts']['lastOnly'] == 2 ? 'checked="checked"': '',' /><label for="lastOnly">' . $txt['RP_lastOnly'] . '</label></td>
					</tr>
					<tr class="windowbg2">
					<td valign="top"><label for="nrofPosts">' . $txt['RP_nrofPosts'] . '</label>&nbsp;
					<select name="nrofPosts" />
					<option ',($context['user']['recentPosts']['nrofPosts'] == 5 ? 'SELECTED' : ''),'>5</option>
					<option ',($context['user']['recentPosts']['nrofPosts'] == 10 || !isset($context['user']['recentPosts']['nrofPosts']) ? 'SELECTED' : ''),'>10</option>
					<option ',($context['user']['recentPosts']['nrofPosts'] == 15 ? 'SELECTED' : ''),'>15</option>
					<option ',($context['user']['recentPosts']['nrofPosts'] == 20 ? 'SELECTED' : ''),'>20</option>
					<option ',($context['user']['recentPosts']['nrofPosts'] == 25 ? 'SELECTED' : ''),'>25</option>
					</select>
					</td>
					</tr></table>';
				}
		echo 		'<table class="bordercolor" width="100%" cellspacing="1" cellpadding="4" border="0">
				<tr class="windowbg2">
				<td valign="top">', 				
				template_profile_save(),'
				</td>
				</tr></table>
				</form>
				</td>
			</tr></table>
				';
	}
}

</add before>


<edit file>
/Sources/Recent.php
</edit file>

<search for>
?>
</search for>
<add before>
// get xx recent topics (read or unread) from ssi_recentTopics and call the unread template to display them nicely
function RecentTopics() {
	global $smcFunc, $context, $settings, $txt, $db_prefix, $user_info, $modSettings, $scripturl, $boarddir;
	require_once($boarddir .'/SSI.php');
	if (!isset($_REQUEST['action'])) $_REQUEST['action'] == 'recenttopics';
	
	if (!empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0)
		$exclude_boards = array($modSettings['recycle_board']);
	else
		$exclude_boards = empty($exclude_boards) ? array() : $exclude_boards;

	$board_limits = '';
	if (isset($_REQUEST['boards']) && is_numeric(str_replace(',','', $_REQUEST['boards']))) {
		$include_boards = explode(',', $_REQUEST['boards']);
		$board_limits = ';boards='.$_REQUEST['boards'];
	}
	elseif (isset($_REQUEST['boards']) && $_REQUEST['boards'] == 'all') {
		$include_boards = null;
		$board_limits = ';boards='.$_REQUEST['boards'];
	}
	else
		$include_boards = $context['user']['recentPosts']['boards'];

	if (isset($_REQUEST['limit']) && is_numeric($_REQUEST['limit'])) {
		if (isset($modSettings['recentpostsLimitdays']) && $modSettings['recentpostsLimitdays'] != 0)
			if ($_REQUEST['limit'] > $modSettings['recentpostsLimitdays']) {
				$limit_days = $modSettings['recentpostsLimitdays'];
			}
			else { $limit_days = $_REQUEST['limit'];}
	}
	elseif (isset($modSettings['recentpostsLimitdays']) && $modSettings['recentpostsLimitdays'] != 0)
		$limit_days = $modSettings['recentpostsLimitdays'];
		
		$request = $smcFunc['db_query']('', "
		SELECT count(*)
		FROM ({$db_prefix}messages AS m, {$db_prefix}topics AS t, {$db_prefix}boards AS b, {$db_prefix}messages AS ms)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.id_member = m.id_member)
		WHERE t.ID_LAST_MSG >= " . (isset($limit_days) ? '0' : ($modSettings['maxMsgID'] - 35 * min($modSettings['defaultMaxTopics'], 5))) . "
			AND t.id_last_msg = m.id_msg
			AND b.id_board = t.id_board" . (empty($exclude_boards) ? '' : "
			AND b.id_board NOT IN (" . implode(', ', $exclude_boards) . ")") . (!empty($include_boards) ? "
			AND b.id_board IN (" . implode(', ', $include_boards) . ")"  : '') . (isset($limit_days) ? "
			AND m.poster_time > " . (time() - ($limit_days*24*60*60)) : '') . (!empty($member_id) ? "	
			AND m.id_member = {$member_id}" : '') .	"
			AND $user_info[query_see_board]
			AND ms.id_msg = t.id_first_msg");

	list($num_topics) = mysql_fetch_row($request);
	$smcFunc['db_free_result']($request);

	$sort_methods = array(
	'subject' => 'ms.subject',
	'starter' => 'IFNULL(mem.real_name, ms.poster_name)',
	'replies' => 't.num_replies',
	'views' => 't.num_views',
	'first_post' => 't.id_topic',
	'last_post' => 't.id_last_msg'
	);
	// The default is the most logical: newest first.
	if (!isset($_REQUEST['sort']) || !isset($sort_methods[$_REQUEST['sort']]))
	{
		$sort_by = 'last_post';
		$_REQUEST['sort'] = 't.id_last_msg';
		$ascending = isset($_REQUEST['asc']);

		$context['querystring_sort_limits'] = $ascending ? ';asc' : '';
	}
	// But, for other methods the default sort is ascending.
	else
	{
		$sort_by = $_REQUEST['sort'];
		$_REQUEST['sort'] = $sort_methods[$_REQUEST['sort']];
		$ascending = !isset($_REQUEST['desc']);

		$context['querystring_sort_limits'] = ';sort=' . $sort_by . ($ascending ? '' : ';desc');
	}
	$context['sort_direction'] = $ascending ? 'up' : 'down';

	$context['linktree'][] = array(
		'url' => $scripturl . '?action=' . $_REQUEST['action'] . $context['querystring_sort_limits'],
		'name' => $txt['recent_topics']
	);		
	// Make sure the starting place makes sense and construct the page index.
	if (!isset($_REQUEST['start'])) $_REQUEST['start'] = 0; 
	$context['querystring_board_limits'] = ';start=%d';
	
	if (isset($limit_days))
		$context['querystring_day_limits'] = ";limit={$limit_days}";
	else $context['querystring_day_limits'] = '';
	
	$context['page_index'] = constructPageIndex($scripturl . '?action=' . $_REQUEST['action'] . $board_limits . $context['querystring_sort_limits'] . $context['querystring_board_limits'] . $context['querystring_day_limits'], $_REQUEST['start'], $num_topics, $modSettings['defaultMaxTopics'], true);
	$context['current_page'] = (int) $_REQUEST['start'] / $modSettings['defaultMaxTopics'];

	$context['links'] = array(
		'first' => $_REQUEST['start'] >= $modSettings['defaultMaxTopics'] ? $scripturl . '?action=' . $_REQUEST['action'] . sprintf($context['querystring_board_limits'], 0) . $context['querystring_day_limits'] . $context['querystring_sort_limits'] : '',
		'prev' => $_REQUEST['start'] >= $modSettings['defaultMaxTopics'] ? $scripturl . '?action=' . $_REQUEST['action'] . sprintf($context['querystring_board_limits'], $_REQUEST['start'] - $modSettings['defaultMaxTopics']) . $context['querystring_day_limits'] . $context['querystring_sort_limits'] : '',
		'next' => $_REQUEST['start'] + $modSettings['defaultMaxTopics'] < $num_topics ? $scripturl . '?action=' . $_REQUEST['action'] . sprintf($context['querystring_board_limits'], $_REQUEST['start'] + $modSettings['defaultMaxTopics']) . $context['querystring_day_limits'] . $context['querystring_sort_limits'] : '',
		'last' => $_REQUEST['start'] + $modSettings['defaultMaxTopics'] < $num_topics ? $scripturl . '?action=' . $_REQUEST['action'] . sprintf($context['querystring_board_limits'], floor(($num_topics - 1) / $modSettings['defaultMaxTopics']) * $modSettings['defaultMaxTopics']) . $context['querystring_day_limits'] . $context['querystring_sort_limits'] : '',
		'up' => $scripturl,
	);
	$context['page_info'] = array(
		'current_page' => $_REQUEST['start'] / $modSettings['defaultMaxTopics'] + 1,
		'num_pages' => floor(($num_topics - 1) / $modSettings['defaultMaxTopics']) + 1
	);
	
	$context['ascending'] = $ascending;
	$context['topics'] = array(); //make sure the array exists so no errors are thrown in Recent.template
	ssi_recentTopics($modSettings['defaultMaxTopics'], null, 'extended', $include_boards, isset($limit_days) ? $limit_days : null);
	$settings['show_mark_read'] = FALSE;
	$context['showing_all_topics'] = null; //to prevent unknown index errors in Recent.template
	//$context['page_index'] = 1;
	$txt['unread_topics_all'] = $txt['unread_topics_only'];
	$txt['unread_topics_visit_none'] = $txt['RP_topics_visit_none'];
	$context['sort_by'] = $sort_by;
	$context['page_title'] = $txt['recent_topics'];
	$context['querystring_board_limits'] = $context['querystring_board_limits'].$board_limits.';start='.$_REQUEST['start'];
	loadTemplate('Recent');
	$context['sub_template'] = 'unread';
}
</add before>

<edit file>
/Themes/default/Recent.template.php
</edit file>
		
<search for>
	if (!empty($context['topics']))
	{
		echo '
					<td width="10%" colspan="2">&nbsp;</td>
					<td>
						<a href="', $scripturl, '?action=unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], ';sort=subject', $context['sort_by'] == 'subject' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['subject'], $context['sort_by'] == 'subject' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="14%">
						<a href="', $scripturl, '?action=unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], ';sort=starter', $context['sort_by'] == 'starter' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['started_by'], $context['sort_by'] == 'starter' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="4%" align="center">
						<a href="', $scripturl, '?action=unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], ';sort=replies', $context['sort_by'] == 'replies' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['replies'], $context['sort_by'] == 'replies' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="4%" align="center">
						<a href="', $scripturl, '?action=unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], ';sort=views', $context['sort_by'] == 'views' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['views'], $context['sort_by'] == 'views' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="24%">
						<a href="', $scripturl, '?action=unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], ';sort=last_post', $context['sort_by'] == 'last_post' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['last_post'], $context['sort_by'] == 'last_post' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td>';
</search for>
<replace>
	if (!empty($context['topics'])) {
		echo '
					<td width="10%" colspan="2">&nbsp;</td>
					<td>
						<a href="', $scripturl, '?action=', isset($_REQUEST['action']) ? $_REQUEST['action'] : 'unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], isset($context['querystring_day_limits']) ? $context['querystring_day_limits'] : '', ';sort=subject', $context['sort_by'] == 'subject' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['subject'], $context['sort_by'] == 'subject' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="14%">
						<a href="', $scripturl, '?action=', isset($_REQUEST['action']) ? $_REQUEST['action'] : 'unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], isset($context['querystring_day_limits']) ? $context['querystring_day_limits'] : '', ';sort=starter', $context['sort_by'] == 'starter' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['started_by'], $context['sort_by'] == 'starter' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="4%" align="center">
						<a href="', $scripturl, '?action=', isset($_REQUEST['action']) ? $_REQUEST['action'] : 'unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], isset($context['querystring_day_limits']) ? $context['querystring_day_limits'] : '', ';sort=replies', $context['sort_by'] == 'replies' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['replies'], $context['sort_by'] == 'replies' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="4%" align="center">
						<a href="', $scripturl, '?action=', isset($_REQUEST['action']) ? $_REQUEST['action'] : 'unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], isset($context['querystring_day_limits']) ? $context['querystring_day_limits'] : '', ';sort=views', $context['sort_by'] == 'views' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['views'], $context['sort_by'] == 'views' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="24%">
						<a href="', $scripturl, '?action=', isset($_REQUEST['action']) ? $_REQUEST['action'] : 'unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], isset($context['querystring_day_limits']) ? $context['querystring_day_limits'] : '', ';sort=last_post', $context['sort_by'] == 'last_post' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['last_post'], $context['sort_by'] == 'last_post' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td>';
</replace>

<search for>
						<img src="' . $settings['images_url'] . '/icons/show_sticky.gif" align="right" alt="" style="margin: 0;" />' : '', $topic['first_post']['link'], ' <a href="', $topic['new_href'], '"><img src="', $settings['lang_images_url'], '/new.gif" alt="', $txt['new'], '" /></a> <span class="smalltext">', $topic['pages'], ' ', $txt['in'], ' ', $topic['board']['link'], '</span></td>
</search for>
<replace>
						<img src="' . $settings['images_url'] . '/icons/show_sticky.gif" align="right" alt="" style="margin: 0;" />' : '', $topic['first_post']['link'], isset($topic['is_new']) && $topic['is_new'] == true ? ' <a href="'. $topic['new_href']. '"><img src="'. $settings['lang_images_url']. '/new.gif" alt="'. $txt['new']. '" /></a>' : '', '<span class="smalltext">', $topic['pages'], ' ', $txt['in'], ' ', $topic['board']['link'], '</span></td>
</replace>


<edit file>
/Sources/BoardIndex.php
</edit file>

<search for>
		$context['latest_posts'] = cache_quick_get('boardindex-latest_posts:' . md5($user_info['query_wanna_see_board'] . $user_info['language']), 'Subs-Recent.php', 'cache_getLastPosts', array($latestPostOptions));
</search for>
<replace>
		global $boarddir;
		require_once($boarddir .'/SSI.php');
		$context['latest_posts'] = ssi_recentPostsPref($latestPostOptions['number_posts'], null, 'array', null, null, null);
</replace>


<edit file>
/index.php
</edit file>

<search for>
		'recent' => array('Recent.php', 'RecentPosts'),
</search for>
<add after>
		'recenttopics' => array('Recent.php', 'RecentTopics'),
</add after>


<edit file>
/Sources/ManageSettings.php
</edit file>

<search for>
			'karma' => array(
</search for>
<add before>
			'recentposts' => array(
				'title' => $txt['recentposts_title'],
				'href' => $scripturl . '?action=featuresettings;sa=recentposts;sesc=' . $context['session_id'],
			),
</add before>
<search for>
		'karma' => 'ModifyKarmaSettings',
</search for>
<add before>
		'recentposts' => 'ModifyRecentpostsSettings',
</add before>

<search for>
		// Mod authors, once again, if you have a whole section to add do it AFTER this line, and keep a comma at the end.
</search for>
<add after>
		'recentposts' => 'ModifyRecentpostsSettings',
</add after>

<search for>
function ModifyLayoutSettings
</search for>
<add before>
function ModifyRecentpostsSettings($return_config = false)
{
	global $txt, $scripturl, $context, $settings, $sc;

	$config_vars = array(
			array('check', 'recentpostsExtraprefs'),
			array('check', 'recentpostsMode'),
			array('int', 'recentpostsNrofposts'),
			array('int', 'recentpostsLimitdays'),
	);

	// Saving?
	if (isset($_GET['save']))
	{
		saveDBSettings($config_vars);
		redirectexit('action=admin;area=modsettings;sa=recentposts');
	}

	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=recentposts';
	$context['settings_title'] = $txt['mods_cat_recentposts'];

	prepareDBSettingContext($config_vars);
}

</add before>


<edit file>
/Sources/Admin.php
</edit file>

<search for>
						// Mod Authors for a "ADD AFTER" on this line. Ensure you end your change with a comma. For example:
</search for>
<add after>
						'recentposts' => array($txt['mods_cat_recentposts']),
</add after>
