<id>
Recent posts user preference
</id>

<version>
1.0
</version>

<mod info>
Per user customization of recent forum posts
</mod info>

<author>
miseryshining
</author>

<homepage>
http://simplemachines.org
</homepage>

<edit file>
/Themes/default/languages/Profile.english.php
</edit file>
<search for>
$txt['no_buddies'] = 'Your buddy list is currently empty';
</search for>
<add after>

$txt['RP_title'] = 'Recent posts settings';
$txt['RP_info'] = 'Here you can setup preferences for the recent post box.';
$txt['RP_blockSettings'] = 'Settings for blocks';
$txt['RP_lastOnly'] = 'Topic view (Only show the last reply of a thread)';
$txt['RP_nrofPosts'] = 'Number of posts to show';
$txt['RP_recentPosts'] = $txt['recentPosts'] = 'Recent posts preferences';
$txt['RP_listheader'] = 'check the boards you want to monitor';
</add after>

<edit file>
/Themes/default/languages/ModSettings.english.php
</edit file>
<search for>
$txt['smf293'] = 'Karma';
</search for>
<add before>
$txt['recentposts_title'] = 'Recent posts/topics';
$txt['recentpostsExtraprefs'] = 'Enable extra user preferences for recent post blocks';
$txt['recentpostsLimitdays'] = 'Timeframe in which to search for recent posts/topics (in days)';
$txt['recentpostsNrofposts'] = 'Number of posts to show in blocks by default';
$txt['recentpostsMode'] = 'Use recent topics mode (instead of posts) on board index';
$helptxt['recentpostsMode'] = 'Will show recent topics instead of posts for members that haven\'t set up their preferences and for guests.';

</add before>

<edit file>
/Themes/default/languages/index.english.php
</edit file>
<search for>
$txt['unread_topics_visit'] 
</search for>
<add before>
$txt['recent_topics'] = 'Recent topics';
$txt['unread_topics_only'] = 'show unread only';
$txt['RP_topics_visit_none'] = 'No recent topics found.';
</add before>

<edit file>
/Sources/Load.php
</edit file>

<search for>
	// Set up the $user_info array.
	$user_info += array(
</search for>
<add after>
		'recentPosts' => array('boards' => (!empty($user_settings['recentpostBoards']) ? explode(',',$user_settings['recentpostBoards']) : array()), 'lastOnly' => (!empty($user_settings['recentLastOnly']) ? $user_settings['recentLastOnly'] : null), 'nrofPosts' => (!empty($user_settings['recentNrofPosts']) ? $user_settings['recentNrofPosts']  : null)),
</add after>

<search for>
	// Set up the contextual user array.
	$context['user'] = array(
</search for>
<add after>
		'recentPosts' => &$user_info['recentPosts'],
</add after>

<edit file>
/SSI.php
</edit file>

<search for>
// Recent post list:   [board] Subject by Poster	Date
function ssi_recentPosts($num_recent = 8, $exclude_boards = null, $output_method = 'echo')
</search for>
<replace>
// Recent posts & topics user preference: 	[board] Subject by Poster	Date
function ssi_recentPostsPref($nrofPosts=null, $boards=null, $returnMode='echo', $mode=null, $limit_days=null, $member_id = null)
{
	global $context, $user_info, $modSettings, $settings;
	if ($user_info['is_guest']) {
		if ($modSettings['recentpostsExtraprefs'] == 1)
			$context['user']['recentPosts']['lastOnly'] = 2;
		else 
			$context['user']['recentPosts']['lastOnly'] = 1;
		$context['user']['recentPosts']['boards'] = '';
	}
	
	if ($nrofPosts == null) {
		if ($modSettings['recentpostsExtraprefs'] == 1 && isset($context['user']['recentPosts']['nrofPosts'])) //user setting 
			$nrofPosts = $context['user']['recentPosts']['nrofPosts'];
		elseif (isset($modSettings['recentpostsNrofposts']) && $modSettings['recentpostsNrofposts'] != 0) //global setting
			$nrofPosts = $modSettings['recentpostsNrofposts'];
		elseif (isset($settings['number_recent_posts']) && $settings['number_recent_posts'] != 0) //theme setting
			$nrofPosts = $settings['number_recent_posts'];
		else $nrofPosts = 10;
	}
	
	if ($limit_days == null && isset($modSettings['recentpostsLimitdays']) && $modSettings['recentpostsLimitdays'] != 0)
		$limit_days = $modSettings['recentpostsLimitdays'];
	
	if ($boards == null) 
		$boards = $context['user']['recentPosts']['boards'];
	elseif ($boards == 'all') 
		$boards = null;

	if ($mode == null) { 
		if (isset($context['user']['recentPosts']['lastOnly']) && $modSettings['recentpostsExtraprefs'] == 1) {
			if ($context['user']['recentPosts']['lastOnly'] == 2) { //topics only
				return ssi_recentTopics($nrofPosts, null, $returnMode, $boards, $limit_days, $member_id);
			}
			else { //posts only
				if ($returnMode == 'extended') $returnMode = 'echo';
				return ssi_recentPosts($nrofPosts, null, $returnMode, $boards, $limit_days, $member_id);
			}
		}
		elseif (isset($modSettings['recentpostsMode']) && $modSettings['recentpostsMode'] != 0) {
			return ssi_recentTopics($nrofPosts, null, $returnMode, $boards, $limit_days, $member_id);
		}
		else {
			if ($returnMode == 'extended') $returnMode = 'echo';
			return ssi_recentPosts($nrofPosts, null, $returnMode, $boards, $limit_days, $member_id);
		}
	}
}

// Recent post list:   [board] Subject by Poster	Date
function ssi_recentPosts($num_recent = 8, $exclude_boards = null, $output_method = 'echo', $include_boards = null, $limit_days = null, $member_id = null)
</replace>

<search for>
	// Find all the posts.  Newer ones will have higher IDs.
	$request = db_query("
		SELECT
			m.posterTime, m.subject, m.ID_TOPIC, m.ID_MEMBER, m.ID_MSG, m.ID_BOARD, b.name AS bName,
			IFNULL(mem.realName, m.posterName) AS posterName, " . ($user_info['is_guest'] ? '1 AS isRead, 0 AS new_from' : '
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, 0)) >= m.ID_MSG_MODIFIED AS isRead,
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, -1)) + 1 AS new_from') . ", LEFT(m.body, 384) AS body, m.smileysEnabled
		FROM ({$db_prefix}messages AS m, {$db_prefix}boards AS b)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)" . (!$user_info['is_guest'] ? "
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = m.ID_TOPIC AND lt.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD = m.ID_BOARD AND lmr.ID_MEMBER = $ID_MEMBER)" : '') . "
		WHERE m.ID_MSG >= " . ($modSettings['maxMsgID'] - 25 * min($num_recent, 5)) . "
			AND b.ID_BOARD = m.ID_BOARD" . (empty($exclude_boards) ? '' : "
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . "
			AND $user_info[query_see_board]
		ORDER BY m.ID_MSG DESC
		LIMIT $num_recent", __FILE__, __LINE__);
</search for>
<replace>
	// Find all the posts.  Newer ones will have higher IDs.
	$request = db_query("
		SELECT
			m.posterTime, m.subject, m.ID_TOPIC, m.ID_MEMBER, m.ID_MSG, m.ID_BOARD, b.name AS bName,
			IFNULL(mem.realName, m.posterName) AS posterName, " . ($user_info['is_guest'] ? '1 AS isRead, 0 AS new_from' : '
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, 0)) >= m.ID_MSG_MODIFIED AS isRead,
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, -1)) + 1 AS new_from') . ", LEFT(m.body, 384) AS body, m.smileysEnabled
		FROM ({$db_prefix}messages AS m, {$db_prefix}boards AS b)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)" . (!$user_info['is_guest'] ? "
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = m.ID_TOPIC AND lt.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD = m.ID_BOARD AND lmr.ID_MEMBER = $ID_MEMBER)" : '') . "
		WHERE m.ID_MSG >= " . (isset($limit_days) ? '0' : ($modSettings['maxMsgID'] - 25 * min($num_recent, 5))) . "
			AND b.ID_BOARD = m.ID_BOARD" . (empty($exclude_boards) ? '' : "
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . (!empty($include_boards) ? "
			AND b.ID_BOARD IN (" . implode(', ', $include_boards) . ")"  : '') . (isset($limit_days) ? "
			AND m.posterTime > " . (time() - ($limit_days*24*60*60)) : '') . (!empty($member_id) ? "	
			AND m.ID_MEMBER = {$member_id}" : '') .	"
			AND $user_info[query_see_board]
		ORDER BY m.ID_MSG DESC
		LIMIT $num_recent", __FILE__, __LINE__);
</replace>

<search for>
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . '#msg' . $row['ID_MSG'] . '">' . $row['subject'] . '</a>',
</search for>
<add before>
			'raw_timestamp' => $row['posterTime'],
</add before>

<search for>
function ssi_recentTopics($num_recent = 8, $exclude_boards = null, $output_method = 'echo')
</search for>
<replace>
function ssi_recentTopics($num_recent = 8, $exclude_boards = null, $output_method = 'echo', $include_boards = null, $limit_days = null, $member_id = null)
</replace>

<search for>
	// Find all the posts in distinct topics.  Newer ones will have higher IDs.
	$request = db_query("
		SELECT
			m.posterTime, ms.subject, m.ID_TOPIC, m.ID_MEMBER, m.ID_MSG, b.ID_BOARD, b.name AS bName,
			IFNULL(mem.realName, m.posterName) AS posterName, " . ($user_info['is_guest'] ? '1 AS isRead, 0 AS new_from' : '
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, 0)) >= m.ID_MSG_MODIFIED AS isRead,
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, -1)) + 1 AS new_from') . ", LEFT(m.body, 384) AS body, m.smileysEnabled, m.icon
		FROM ({$db_prefix}messages AS m, {$db_prefix}topics AS t, {$db_prefix}boards AS b, {$db_prefix}messages AS ms)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)" . (!$user_info['is_guest'] ? "
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = t.ID_TOPIC AND lt.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD = b.ID_BOARD AND lmr.ID_MEMBER = $ID_MEMBER)" : '') . "
		WHERE t.ID_LAST_MSG >= " . ($modSettings['maxMsgID'] - 35 * min($num_recent, 5)) . "
			AND t.ID_LAST_MSG = m.ID_MSG
			AND b.ID_BOARD = t.ID_BOARD" . (empty($exclude_boards) ? '' : "
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . "
			AND $user_info[query_see_board]
			AND ms.ID_MSG = t.ID_FIRST_MSG
		ORDER BY t.ID_LAST_MSG DESC
		LIMIT $num_recent", __FILE__, __LINE__);
</search for>
<replace>
	// Find all the posts in distinct topics.  Newer ones will have higher IDs.
	$extravalues = '';
	if ($output_method == 'extended') {
		// get all the extra information about topics, so we can send them to Recent.template.php later
		$extravalues = "ms.subject AS firstSubject, ms.posterTime AS firstPosterTime, ms.ID_TOPIC, t.ID_BOARD, b.name AS bname,
		t.numReplies, t.numViews, ms.ID_MEMBER AS ID_FIRST_MEMBER, m.ID_MEMBER AS ID_LAST_MEMBER,
		m.posterTime AS lastPosterTime, memfp.realName AS firstPosterName,
		mem.realName AS lastPosterName, m.subject AS lastSubject,
		m.icon AS lastIcon, ms.icon AS firstIcon, t.ID_POLL, t.isSticky, t.locked, m.modifiedTime AS lastModifiedTime, 
		" . (!$user_info['is_guest'] ? "
		IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, -1)) + 1 AS new_from," : '') . " LEFT(m.body, 384) AS lastBody, LEFT(ms.body, 384) AS firstBody,
		m.smileysEnabled AS lastSmileys, ms.smileysEnabled AS firstSmileys, t.ID_FIRST_MSG, t.ID_LAST_MSG, ";
	}
	$request = db_query("
		SELECT {$extravalues}
			m.posterTime, ms.subject, m.ID_TOPIC, m.ID_MEMBER, m.ID_MSG, b.ID_BOARD, b.name AS bName,
			IFNULL(mem.realName, m.posterName) AS posterName, " . ($user_info['is_guest'] ? '1 AS isRead, 0 AS new_from' : '
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, 0)) >= m.ID_MSG_MODIFIED AS isRead,
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, -1)) + 1 AS new_from') . ", LEFT(m.body, 384) AS body, m.smileysEnabled, m.icon
		FROM ({$db_prefix}messages AS m, {$db_prefix}topics AS t, {$db_prefix}boards AS b, {$db_prefix}messages AS ms)
			LEFT JOIN {$db_prefix}members AS memfp ON (memfp.ID_MEMBER = ms.ID_MEMBER)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)" . (!$user_info['is_guest'] ? "
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = t.ID_TOPIC AND lt.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD = b.ID_BOARD AND lmr.ID_MEMBER = $ID_MEMBER)" : '') . "
		WHERE t.ID_LAST_MSG >= " . (isset($limit_days) ? '0' : ($modSettings['maxMsgID'] - 35 * min($num_recent, 5))) . "
			AND t.ID_LAST_MSG = m.ID_MSG
			AND b.ID_BOARD = t.ID_BOARD" . (empty($exclude_boards) ? '' : "
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . (!empty($include_boards) ? "
			AND b.ID_BOARD IN (" . implode(', ', $include_boards) . ")"  : '') . (isset($limit_days) ? "
			AND m.posterTime > " . (time() - ($limit_days*24*60*60)) : '') . (!empty($member_id) ? "	
			AND m.ID_MEMBER = {$member_id}" : '') .	"
			AND $user_info[query_see_board]
			AND ms.ID_MSG = t.ID_FIRST_MSG
		ORDER BY " . ($output_method == 'extended' && isset($_REQUEST['sort']) ? (
			$_REQUEST['sort'] . ($context['ascending'] ? '' : ' DESC')) : ("t.ID_LAST_MSG DESC")) . "
		LIMIT " . (($output_method == 'extended' && isset($_REQUEST['start']) && isset($_REQUEST['action']) && $_REQUEST['action'] == 'recenttopics' && is_numeric($_REQUEST['start'])) ? ($_REQUEST['start'].', ') : ('')) . $num_recent, __FILE__, __LINE__);
</replace>

<search for>
	while ($row = mysql_fetch_assoc($request))
	{
		$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']), array('<br />' => '&#10;')));
		if ($func['strlen']($row['body']) > 128)
			$row['body'] = $func['substr']($row['body'], 0, 128) . '...';

		// Censor the subject.
		censorText($row['subject']);
		censorText($row['body']);

		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		// Build the array.
		$posts[] = array(
			'board' => array(
				'id' => $row['ID_BOARD'],
				'name' => $row['bName'],
				'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
				'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bName'] . '</a>'
			),
			'topic' => $row['ID_TOPIC'],
			'poster' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['posterName'],
				'href' => empty($row['ID_MEMBER']) ? '' : $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
				'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'subject' => $row['subject'],
			'short_subject' => shorten_subject($row['subject'], 25),
			'preview' => $row['body'],
			'time' => timeformat($row['posterTime']),
			'timestamp' => forum_time(true, $row['posterTime']),
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . '#new">' . $row['subject'] . '</a>',
			'new' => !empty($row['isRead']),
			'new_from' => $row['new_from'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
		);
	}
</search for>
<replace>
	while ($row = mysql_fetch_assoc($request))
	{
		// this puts the extended topic information into $context['topics']. it's copied from Recent.php and can be used by template_unread() in Recent.template.php
		if ($output_method == 'extended') { 
			//set these variables so there will be no undefined indexes
			$context['querystring_board_limits'] = '';
			$context['sort_by'] = '';

			if ($row['ID_POLL'] > 0 && $modSettings['pollMode'] == '0')
				continue;
	
			$topic_ids[] = $row['ID_TOPIC'];
	
			// Clip the strings first because censoring is slow :/. (for some reason?)
			$row['firstBody'] = strip_tags(strtr(parse_bbc($row['firstBody'], $row['firstSmileys'], $row['ID_FIRST_MSG']), array('<br />' => '&#10;')));
			if ($func['strlen']($row['firstBody']) > 128)
				$row['firstBody'] = $func['substr']($row['firstBody'], 0, 128) . '...';
			$row['lastBody'] = strip_tags(strtr(parse_bbc($row['lastBody'], $row['lastSmileys'], $row['ID_LAST_MSG']), array('<br />' => '&#10;')));
			if ($func['strlen']($row['lastBody']) > 128)
				$row['lastBody'] = $func['substr']($row['lastBody'], 0, 128) . '...';
	
			// Do a bit of censoring...
			censorText($row['firstSubject']);
			censorText($row['firstBody']);
	
			// But don't do it twice, it can be a slow ordeal!
			if ($row['ID_FIRST_MSG'] == $row['ID_LAST_MSG'])
			{
				$row['lastSubject'] = $row['firstSubject'];
				$row['lastBody'] = $row['firstBody'];
			}
			else
			{
				censorText($row['lastSubject']);
				censorText($row['lastBody']);
			}
	
			// Decide how many pages the topic should have.
			$topic_length = $row['numReplies'] + 1;
			if ($topic_length > $modSettings['defaultMaxMessages'])
			{
				$tmppages = array();
				$tmpa = 1;
				for ($tmpb = 0; $tmpb < $topic_length; $tmpb += $modSettings['defaultMaxMessages'])
				{
					$tmppages[] = '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.' . $tmpb . ';topicseen">' . $tmpa . '</a>';
					$tmpa++;
				}
				// Show links to all the pages?
				if (count($tmppages) <= 5)
					$pages = '&#171; ' . implode(' ', $tmppages);
				// Or skip a few?
				else
					$pages = '&#171; ' . $tmppages[0] . ' ' . $tmppages[1] . ' ... ' . $tmppages[count($tmppages) - 2] . ' ' . $tmppages[count($tmppages) - 1];
	
				if (!empty($modSettings['enableAllMessages']) && $topic_length < $modSettings['enableAllMessages'])
					$pages .= ' &nbsp;<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;all">' . $txt[190] . '</a>';
				$pages .= ' &#187;';
			}
			else
				$pages = '';
	
			// We need to check the topic icons exist... you can never be too sure!
			if (empty($modSettings['messageIconChecks_disable']))
			{
				// First icon first... as you'd expect.
				if (!isset($context['icon_sources'][$row['firstIcon']]))
					$context['icon_sources'][$row['firstIcon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['firstIcon'] . '.gif') ? 'images_url' : 'default_images_url';
				// Last icon... last... duh.
				if (!isset($context['icon_sources'][$row['lastIcon']]))
					$context['icon_sources'][$row['lastIcon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['lastIcon'] . '.gif') ? 'images_url' : 'default_images_url';
			}
	
			// And build the array.
			$context['topics'][$row['ID_TOPIC']] = array(
				'id' => $row['ID_TOPIC'],
				'first_post' => array(
					'id' => $row['ID_FIRST_MSG'],
					'member' => array(
						'name' => $row['firstPosterName'],
						'id' => $row['ID_FIRST_MEMBER'],
						'href' => $scripturl . '?action=profile;u=' . $row['ID_FIRST_MEMBER'],
						'link' => !empty($row['ID_FIRST_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_FIRST_MEMBER'] . '" title="' . $txt[92] . ' ' . $row['firstPosterName'] . '">' . $row['firstPosterName'] . '</a>' : $row['firstPosterName']
					),
					'time' => timeformat($row['firstPosterTime']),
					'timestamp' => forum_time(true, $row['firstPosterTime']),
					'subject' => $row['firstSubject'],
					'preview' => $row['firstBody'],
					'icon' => $row['firstIcon'],
					'icon_url' => $settings[$context['icon_sources'][$row['firstIcon']]] . '/post/' . $row['firstIcon'] . '.gif',
					'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;topicseen',
					'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;topicseen">' . $row['firstSubject'] . '</a>'
				),
				'last_post' => array(
					'id' => $row['ID_LAST_MSG'],
					'member' => array(
						'name' => $row['lastPosterName'],
						'id' => $row['ID_LAST_MEMBER'],
						'href' => $scripturl . '?action=profile;u=' . $row['ID_LAST_MEMBER'],
						'link' => !empty($row['ID_LAST_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_LAST_MEMBER'] . '">' . $row['lastPosterName'] . '</a>' : $row['lastPosterName']
					),
					'time' => timeformat($row['lastPosterTime']),
					'timestamp' => forum_time(true, $row['lastPosterTime']),
					'subject' => $row['lastSubject'],
					'preview' => $row['lastBody'],
					'icon' => $row['lastIcon'],
					'icon_url' => $settings[$context['icon_sources'][$row['lastIcon']]] . '/post/' . $row['lastIcon'] . '.gif',
					'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . ($row['numReplies'] == 0 ? '.0' : '.msg' . $row['ID_LAST_MSG']) . ';topicseen#msg' . $row['ID_LAST_MSG'],
					'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . ($row['numReplies'] == 0 ? '.0' : '.msg' . $row['ID_LAST_MSG']) . ';topicseen#msg' . $row['ID_LAST_MSG'] . '">' . $row['lastSubject'] . '</a>'
				),
				'new_from' => $row['new_from'],
				'new_href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['new_from'] . ';topicseen#new',
				'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . ($row['numReplies'] == 0 ? '.0' : '.msg' . $row['new_from']) . ';topicseen' . ($row['numReplies'] == 0 ? '' : 'new'),
				'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . ($row['numReplies'] == 0 ? '.0' : '.msg' . $row['new_from']) . ';topicseen#msg' . $row['new_from'] . '">' . $row['firstSubject'] . '</a>',
				'is_read' => $row['isRead'],
				'is_sticky' => !empty($modSettings['enableStickyTopics']) && !empty($row['isSticky']),
				'is_locked' => !empty($row['locked']),
				'is_poll' => $modSettings['pollMode'] == '1' && $row['ID_POLL'] > 0,
				'is_hot' => $row['numReplies'] >= $modSettings['hotTopicPosts'],
				'is_very_hot' => $row['numReplies'] >= $modSettings['hotTopicVeryPosts'],
				'is_posted_in' => false,
				'icon' => $row['firstIcon'],
				'icon_url' => $settings[$context['icon_sources'][$row['firstIcon']]] . '/post/' . $row['firstIcon'] . '.gif',
				'subject' => $row['firstSubject'],
				'pages' => $pages,
				'replies' => $row['numReplies'],
				'views' => $row['numViews'],
				'board' => array(
					'id' => $row['ID_BOARD'],
					'name' => $row['bname'],
					'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
					'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bname'] . '</a>'
				)
			);
	
			determineTopicClass($context['topics'][$row['ID_TOPIC']]);
		}
		else {
			$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']), array('<br />' => '&#10;')));
			if ($func['strlen']($row['body']) > 128)
				$row['body'] = $func['substr']($row['body'], 0, 128) . '...';
	
			// Censor the subject.
			censorText($row['subject']);
			censorText($row['body']);
	
			if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
				$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';
	
			// Build the array.
			$posts[] = array(
				'board' => array(
					'id' => $row['ID_BOARD'],
					'name' => $row['bName'],
					'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
					'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bName'] . '</a>'
				),
				'topic' => $row['ID_TOPIC'],
				'poster' => array(
					'id' => $row['ID_MEMBER'],
					'name' => $row['posterName'],
					'href' => empty($row['ID_MEMBER']) ? '' : $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
					'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
				),
				'subject' => $row['subject'],
				'short_subject' => shorten_subject($row['subject'], 25),
				'preview' => $row['body'],
				'time' => timeformat($row['posterTime']),
				'timestamp' => forum_time(true, $row['posterTime']),
				'raw_timestamp' => $row['posterTime'],
				'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . ';topicseen#new',
				'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . '#new">' . $row['subject'] . '</a>',
				'new' => !empty($row['isRead']),
				'new_from' => $row['new_from'],
				'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
			);
		}
	}
</replace>


<edit file>
/Sources/Profile.php
</edit file>

<search for>
		'theme' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any')),
</search for>
<add after>
		'recentPosts' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any')),
</add after>

<search for>
			$context['profile_areas']['edit_profile']['areas']['theme'] = '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=theme">' . $txt['theme'] . '</a>';
</search for>
<add after>
			$context['profile_areas']['edit_profile']['areas']['recentPosts'] = '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=recentPosts">' . $txt['RP_recentPosts'] . '</a>';
</add after>

<search for>
		'theme' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any'), 'post'),
</search for>
<add after>
		'recentPosts' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any'), 'post'),
</add after>

<search for>
		makeThemeChanges($memID, isset($_POST['ID_THEME']) ? (int) $_POST['ID_THEME'] : $old_profile['ID_THEME']);
</search for>
<add after>
		makeRecentPostsChanges($memID);
</add after>

<search for>
// Make any notification changes that need to be made.
function makeNotificationChanges($memID)
</search for>
<add before>
// Make any recent board changes that are sent with the profile..
function makeRecentPostsChanges($memID)
{
	global $db_prefix, $modSettings;

	//recent posts settings are changed
	if (isset($_POST['sa']) && $_POST['sa'] == 'recentPosts') {
		$boardRecentStr = isset($_POST['boardRecent']) ? implode(',', $_POST['boardRecent']) : 0;
		if (isset($_POST['lastOnly']))
			$recentLastOnly = 2; 
		else $recentLastOnly = 1;
		if (empty($_POST['nrofPosts'])) $_POST['nrofPosts'] = 10;
	
		db_query("
			UPDATE {$db_prefix}members 
			SET recentpostBoards = '{$boardRecentStr}',
			recentLastOnly = $recentLastOnly,
			recentNrofPosts = {$_POST['nrofPosts']}
			WHERE ID_MEMBER = {$memID} LIMIT 1", __FILE__, __LINE__);
	}
}

</add before>

<search for>
// Display the notifications and settings for changes.
function notification($memID)
</search for>
<add before>
function recentPosts($memID)
{
	global $txt, $context, $user_profile, $db_prefix, $modSettings, $settings, $user_info, $ID_MEMBER;

	//select user preference if $memID != user ID. 
	if ($ID_MEMBER != $memID) {
		$result = db_query("SELECT recentpostBoards, recentLastOnly, recentNrofPosts FROM {$db_prefix}members WHERE ID_MEMBER = {$memID} LIMIT 1", __FILE__, __LINE__);
		$row = mysql_fetch_assoc($result);
		$context['user']['recentPosts']['boards'] = !empty($row['recentpostBoards']) ? explode(',',$row['recentpostBoards']) : array();
		$context['user']['recentPosts']['lastOnly'] = $row['recentLastOnly'];
		$context['user']['recentPosts']['nrofPosts'] = !empty($row['recentNrofPosts']) ? $row['recentNrofPosts'] : "10";
	}
	

	$recentpostBoards = $context['user']['recentPosts']['boards'];

	$result = db_query("
		SELECT ID_GROUP, groupName
		FROM {$db_prefix}membergroups
		WHERE (ID_GROUP > 3 OR ID_GROUP = 2)" . (empty($modSettings['permission_enable_postgroups']) ? "
			AND minPosts = -1" : '') . "
		ORDER BY minPosts, ID_GROUP != 2, groupName", __FILE__, __LINE__);
	$context['groups'] = array();
	while ($row = mysql_fetch_assoc($result))
		$context['groups'][] = array(
			'id' => $row['ID_GROUP'],
			'name' => $row['groupName']
		);
	mysql_free_result($result);
		
	$result_boards = db_query("
		SELECT
			b.ID_BOARD, b.name AS boardName, b.childlevel, b.description,
			b.numPosts, b.numTopics, b.ID_PARENT
		FROM {$db_prefix}boards AS b
		WHERE $user_info[query_see_board]" . (empty($modSettings['countChildPosts']) ? "
			AND b.childLevel <= 1" : ''), __FILE__, __LINE__);

		$context['boards'] = array();
		while ($row = mysql_fetch_assoc($result_boards))
		$context['boards'][] = array(
			'id' => $row['ID_BOARD'],
			'name' => $row['boardName'],
			'child_level' => $row['childlevel'],
			'selected' => false,
			'monitor' => (in_array($row['ID_BOARD'],$recentpostBoards)) ? 1 : -1
		);
		mysql_free_result($result_boards);
	
	loadThemeOptions($memID);

	loadLanguage('Settings');
}

</add before>


<edit file>
/Themes/default/Profile.template.php
</edit file>

<search for>
function template_notification()
</search for>
<add before>
// Template for showing recent posts settings.
function template_recentPosts()
{
	global $context, $settings, $options, $scripturl, $modSettings, $txt, $user_info;
	
	if (!empty($context['boards']))
	{
		echo '
			<table border="0" width="85%" cellspacing="1" cellpadding="4" align="center" class="bordercolor">
				<tr class="titlebg">
					<td height="26">
						&nbsp;<img src="', $settings['images_url'], '/icons/profile_sm.gif" alt="" border="0" align="top" />&nbsp;
						' . $txt['RP_title'] . '
					</td>
				</tr><tr class="windowbg">
					<td class="smalltext" height="25" style="padding: 2ex;">
						' . $txt['RP_info'] . '
					</td>
				</tr><tr>
				<td class="windowbg2" style="padding-bottom: 2ex;">
				<form action="', $scripturl, '?action=profile2" method="post" accept-charset="', $context['character_set'], '" style="margin: 0;">
				<table border="0" width="100%" cellpadding="3">
				  	<tr class="windowbg2">
					<td valign="top">
						<fieldset>
						<legend>',$txt['RP_listheader'],'</legend>';
						foreach ($context['boards'] as $board) {
							echo '<div style="margin-left: ', $board['child_level'], 'em;"><input type="checkbox" name="boardRecent[]" id="boardaccess_', $board['id'], '" value="', $board['id'], '" ', $board['monitor'] == 1 ? ' checked="checked"' : '', ' class="check" /> <label for="boardaccess_', $board['id'], '">', $board['name'], '</label></div>';
						}

		echo '<br />
							<input type="checkbox" id="checkall_check" class="check" onclick="invertAll(this, this.form, \'boardRecent\');" /> <label for="checkall_check"><i>', $txt[737], '</i></label>
						</fieldset>
					</td>
				</tr></table>';
				if ($modSettings['recentpostsExtraprefs'] == 1) { 					
		echo '			<table class="bordercolor" width="100%" cellspacing="1" cellpadding="4" border="0" style="margin-top: 10px;">
					<tr>
					<td class="catbg" width="100%">',$txt['RP_blockSettings'],'</td>
					</tr>
					<tr class="windowbg2">
					<td valign="top"><input type="checkbox" class="check" name="lastOnly" id="lastOnly" ', $context['user']['recentPosts']['lastOnly'] == 2 ? 'checked="checked"': '',' /><label for="lastOnly">' . $txt['RP_lastOnly'] . '</label></td>
					</tr>
					<tr class="windowbg2">
					<td valign="top"><label for="nrofPosts">' . $txt['RP_nrofPosts'] . '</label>&nbsp;
					<select name="nrofPosts" />
					<option ',($context['user']['recentPosts']['nrofPosts'] == 5 ? 'SELECTED' : ''),'>5</option>
					<option ',($context['user']['recentPosts']['nrofPosts'] == 10 || !isset($context['user']['recentPosts']['nrofPosts']) ? 'SELECTED' : ''),'>10</option>
					<option ',($context['user']['recentPosts']['nrofPosts'] == 15 ? 'SELECTED' : ''),'>15</option>
					<option ',($context['user']['recentPosts']['nrofPosts'] == 20 ? 'SELECTED' : ''),'>20</option>
					<option ',($context['user']['recentPosts']['nrofPosts'] == 25 ? 'SELECTED' : ''),'>25</option>
					</select>
					</td>
					</tr></table>';
				}
		echo 		'<table class="bordercolor" width="100%" cellspacing="1" cellpadding="4" border="0">
				<tr class="windowbg2">
				<td valign="top">', 				
				template_profile_save(),'
				</td>
				</tr></table>
				</form>
				</td>
			</tr></table>
				';
	}
}

</add before>


<edit file>
/Sources/Recent.php
</edit file>

<search for>
?>
</search for>
<add before>
// get xx recent topics (read or unread) from ssi_recentTopics and call the unread template to display them nicely
function RecentTopics() {
	global $context, $settings, $txt, $db_prefix, $ID_MEMBER, $user_info, $modSettings, $scripturl;
	require_once('SSI.php');
	if (!isset($_REQUEST['action'])) $_REQUEST['action'] == 'recenttopics';
	
	if (!empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0)
		$exclude_boards = array($modSettings['recycle_board']);
	else
		$exclude_boards = empty($exclude_boards) ? array() : $exclude_boards;

	$board_limits = '';
	if (isset($_REQUEST['boards']) && is_numeric(str_replace(',','', $_REQUEST['boards']))) {
		$include_boards = explode(',', $_REQUEST['boards']);
		$board_limits = ';boards='.$_REQUEST['boards'];
	}
	elseif (isset($_REQUEST['boards']) && $_REQUEST['boards'] == 'all') {
		$include_boards = null;
		$board_limits = ';boards='.$_REQUEST['boards'];
	}
	else
		$include_boards = $context['user']['recentPosts']['boards'];

	if (isset($_REQUEST['limit']) && is_numeric($_REQUEST['limit'])) {
		if (isset($modSettings['recentpostsLimitdays']) && $modSettings['recentpostsLimitdays'] != 0)
			if ($_REQUEST['limit'] > $modSettings['recentpostsLimitdays']) {
				$limit_days = $modSettings['recentpostsLimitdays'];
			}
			else { $limit_days = $_REQUEST['limit'];}
	}
	elseif (isset($modSettings['recentpostsLimitdays']) && $modSettings['recentpostsLimitdays'] != 0)
		$limit_days = $modSettings['recentpostsLimitdays'];
		
		$request = db_query("
		SELECT count(*)
		FROM ({$db_prefix}messages AS m, {$db_prefix}topics AS t, {$db_prefix}boards AS b, {$db_prefix}messages AS ms)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
		WHERE t.ID_LAST_MSG >= " . (isset($limit_days) ? '0' : ($modSettings['maxMsgID'] - 35 * min($modSettings['defaultMaxTopics'], 5))) . "
			AND t.ID_LAST_MSG = m.ID_MSG
			AND b.ID_BOARD = t.ID_BOARD" . (empty($exclude_boards) ? '' : "
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . (!empty($include_boards) ? "
			AND b.ID_BOARD IN (" . implode(', ', $include_boards) . ")"  : '') . (isset($limit_days) ? "
			AND m.posterTime > " . (time() - ($limit_days*24*60*60)) : '') . (!empty($member_id) ? "	
			AND m.ID_MEMBER = {$member_id}" : '') .	"
			AND $user_info[query_see_board]
			AND ms.ID_MSG = t.ID_FIRST_MSG
		", __FILE__, __LINE__);
	list($num_topics) = mysql_fetch_row($request);
	mysql_free_result($request);

	$sort_methods = array(
	'subject' => 'ms.subject',
	'starter' => 'IFNULL(mem.realName, ms.posterName)',
	'replies' => 't.numReplies',
	'views' => 't.numViews',
	'first_post' => 't.ID_TOPIC',
	'last_post' => 't.ID_LAST_MSG'
	);
	// The default is the most logical: newest first.
	if (!isset($_REQUEST['sort']) || !isset($sort_methods[$_REQUEST['sort']]))
	{
		$sort_by = 'last_post';
		$_REQUEST['sort'] = 't.ID_LAST_MSG';
		$ascending = isset($_REQUEST['asc']);

		$context['querystring_sort_limits'] = $ascending ? ';asc' : '';
	}
	// But, for other methods the default sort is ascending.
	else
	{
		$sort_by = $_REQUEST['sort'];
		$_REQUEST['sort'] = $sort_methods[$_REQUEST['sort']];
		$ascending = !isset($_REQUEST['desc']);

		$context['querystring_sort_limits'] = ';sort=' . $sort_by . ($ascending ? '' : ';desc');
	}
	$context['sort_direction'] = $ascending ? 'up' : 'down';

	$context['linktree'][] = array(
		'url' => $scripturl . '?action=' . $_REQUEST['action'] . $context['querystring_sort_limits'],
		'name' => $txt['recent_topics']
	);		
	// Make sure the starting place makes sense and construct the page index.
	if (!isset($_REQUEST['start'])) $_REQUEST['start'] = 0; 
	$context['querystring_board_limits'] = ';start=%d';
	
	if (isset($limit_days))
		$context['querystring_day_limits'] = ";limit={$limit_days}";
	else $context['querystring_day_limits'] = '';
	
	$context['page_index'] = constructPageIndex($scripturl . '?action=' . $_REQUEST['action'] . $board_limits . $context['querystring_sort_limits'] . $context['querystring_board_limits'] . $context['querystring_day_limits'], $_REQUEST['start'], $num_topics, $modSettings['defaultMaxTopics'], true);
	$context['current_page'] = (int) $_REQUEST['start'] / $modSettings['defaultMaxTopics'];

	$context['links'] = array(
		'first' => $_REQUEST['start'] >= $modSettings['defaultMaxTopics'] ? $scripturl . '?action=' . $_REQUEST['action'] . sprintf($context['querystring_board_limits'], 0) . $context['querystring_day_limits'] . $context['querystring_sort_limits'] : '',
		'prev' => $_REQUEST['start'] >= $modSettings['defaultMaxTopics'] ? $scripturl . '?action=' . $_REQUEST['action'] . sprintf($context['querystring_board_limits'], $_REQUEST['start'] - $modSettings['defaultMaxTopics']) . $context['querystring_day_limits'] . $context['querystring_sort_limits'] : '',
		'next' => $_REQUEST['start'] + $modSettings['defaultMaxTopics'] < $num_topics ? $scripturl . '?action=' . $_REQUEST['action'] . sprintf($context['querystring_board_limits'], $_REQUEST['start'] + $modSettings['defaultMaxTopics']) . $context['querystring_day_limits'] . $context['querystring_sort_limits'] : '',
		'last' => $_REQUEST['start'] + $modSettings['defaultMaxTopics'] < $num_topics ? $scripturl . '?action=' . $_REQUEST['action'] . sprintf($context['querystring_board_limits'], floor(($num_topics - 1) / $modSettings['defaultMaxTopics']) * $modSettings['defaultMaxTopics']) . $context['querystring_day_limits'] . $context['querystring_sort_limits'] : '',
		'up' => $scripturl,
	);
	$context['page_info'] = array(
		'current_page' => $_REQUEST['start'] / $modSettings['defaultMaxTopics'] + 1,
		'num_pages' => floor(($num_topics - 1) / $modSettings['defaultMaxTopics']) + 1
	);
	
	$context['ascending'] = $ascending;
	$context['topics'] = array(); //make sure the array exists so no errors are thrown in Recent.template
	ssi_recentTopics($modSettings['defaultMaxTopics'], null, 'extended', $include_boards, isset($limit_days) ? $limit_days : null);
	$settings['show_mark_read'] = FALSE;
	$context['showing_all_topics'] = null; //to prevent unknown index errors in Recent.template
	//$context['page_index'] = 1;
	$txt['unread_topics_all'] = $txt['unread_topics_only'];
	$txt['unread_topics_visit_none'] = $txt['RP_topics_visit_none'];
	$context['sort_by'] = $sort_by;
	$context['page_title'] = $txt['recent_topics'];
	$context['querystring_board_limits'] = $context['querystring_board_limits'].$board_limits.';start='.$_REQUEST['start'];
	loadTemplate('Recent');
	$context['sub_template'] = 'unread';
}
</add before>

<edit file>
/Themes/default/Recent.template.php
</edit file>
<search for>
		// Do we want to seperate the sticky and lock status out?
</search for>
<add before>
		if (!isset($topic['is_read'])) $topic['is_read'] = 0;
</add before>
		
<search for>
	if (!empty($context['topics']))
		echo '
					<td width="10%" colspan="2">&nbsp;</td>
					<td>
						<a href="', $scripturl, '?action=unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], ';sort=subject', $context['sort_by'] == 'subject' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[70], $context['sort_by'] == 'subject' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="14%">
						<a href="', $scripturl, '?action=unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], ';sort=starter', $context['sort_by'] == 'starter' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[109], $context['sort_by'] == 'starter' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="4%" align="center">
						<a href="', $scripturl, '?action=unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], ';sort=replies', $context['sort_by'] == 'replies' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[110], $context['sort_by'] == 'replies' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="4%" align="center">
						<a href="', $scripturl, '?action=unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], ';sort=views', $context['sort_by'] == 'views' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[301], $context['sort_by'] == 'views' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="24%">
						<a href="', $scripturl, '?action=unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], ';sort=last_post', $context['sort_by'] == 'last_post' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[111], $context['sort_by'] == 'last_post' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td>';
</search for>
<replace>
	if (!empty($context['topics']))
		echo '
					<td width="10%" colspan="2">&nbsp;</td>
					<td>
						<a href="', $scripturl, '?action=', isset($_REQUEST['action']) ? $_REQUEST['action'] : 'unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], isset($context['querystring_day_limits']) ? $context['querystring_day_limits'] : '', ';sort=subject', $context['sort_by'] == 'subject' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[70], $context['sort_by'] == 'subject' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="14%">
						<a href="', $scripturl, '?action=', isset($_REQUEST['action']) ? $_REQUEST['action'] : 'unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], isset($context['querystring_day_limits']) ? $context['querystring_day_limits'] : '', ';sort=starter', $context['sort_by'] == 'starter' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[109], $context['sort_by'] == 'starter' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="4%" align="center">
						<a href="', $scripturl, '?action=', isset($_REQUEST['action']) ? $_REQUEST['action'] : 'unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], isset($context['querystring_day_limits']) ? $context['querystring_day_limits'] : '', ';sort=replies', $context['sort_by'] == 'replies' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[110], $context['sort_by'] == 'replies' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="4%" align="center">
						<a href="', $scripturl, '?action=', isset($_REQUEST['action']) ? $_REQUEST['action'] : 'unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], isset($context['querystring_day_limits']) ? $context['querystring_day_limits'] : '', ';sort=views', $context['sort_by'] == 'views' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[301], $context['sort_by'] == 'views' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td><td width="24%">
						<a href="', $scripturl, '?action=', isset($_REQUEST['action']) ? $_REQUEST['action'] : 'unread', $context['showing_all_topics'] ? ';all' : '', $context['querystring_board_limits'], isset($context['querystring_day_limits']) ? $context['querystring_day_limits'] : '', ';sort=last_post', $context['sort_by'] == 'last_post' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[111], $context['sort_by'] == 'last_post' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a>
					</td>';
</replace>

<search for>
						<img src="' . $settings['images_url'] . '/icons/show_sticky.gif" align="right" alt="" style="margin: 0;" />' : '', $topic['first_post']['link'], ' <a href="', $topic['new_href'], '"><img src="', $settings['images_url'], '/', $context['user']['language'], '/new.gif" alt="', $txt[302], '" /></a> <span class="smalltext">', $topic['pages'], ' ', $txt['smf88'], ' ', $topic['board']['link'], '</span></td>
</search for>
<replace>
						<img src="' . $settings['images_url'] . '/icons/show_sticky.gif" align="right" alt="" style="margin: 0;" />' : '', $topic['first_post']['link'], $topic['is_read'] == 0 ? ' <a href="'. $topic['new_href']. '"><img src="'. $settings['images_url']. '/'. $context['user']['language']. '/new.gif" alt="'. $txt[302]. '" /></a>' : '', '<span class="smalltext">', $topic['pages'], ' ', $txt['smf88'], ' ', $topic['board']['link'], '</span></td>
</replace>


<edit file>
/Sources/BoardIndex.php
</edit file>

<search for>
		require_once($sourcedir . '/Recent.php');
</search for>
<replace>
		require_once('SSI.php');
</replace>

<search for>
getLastPosts($settings['number_recent_posts'])
</search for>
<replace>
ssi_recentPostsPref(null, null,	'array', null, null, null);
</replace>

<edit file>
/index.php
</edit file>

<search for>
		'recent' => array('Recent.php', 'RecentPosts'),
</search for>
<add after>
		'recenttopics' => array('Recent.php', 'RecentTopics'),
</add after>

<edit file>
/Sources/ModSettings.php
</edit file>

<search for>
			'karma' => array(
</search for>
<add before>
			'recentposts' => array(
				'title' => $txt['recentposts_title'],
				'href' => $scripturl . '?action=featuresettings;sa=recentposts;sesc=' . $context['session_id'],
			),
</add before>
<search for>
		'karma' => 'ModifyKarmaSettings',
</search for>
<add before>
		'recentposts' => 'ModifyRecentpostsSettings',
</add before>

<search for>
function ModifyLayoutSettings()
</search for>
<add before>
function ModifyRecentpostsSettings()
{
	global $txt, $scripturl, $context, $settings, $sc;

	$config_vars = array(
			array('check', 'recentpostsExtraprefs'),
			array('check', 'recentpostsMode'),
			array('int', 'recentpostsNrofposts'),
			array('int', 'recentpostsLimitdays'),
	);

	// Saving?
	if (isset($_GET['save']))
	{
		saveDBSettings($config_vars);
		redirectexit('action=featuresettings;sa=recentposts');
	}

	$context['post_url'] = $scripturl . '?action=featuresettings2;save;sa=recentposts';
	$context['settings_title'] = $txt['recentposts_title'];

	prepareDBSettingContext($config_vars);
}

</add before>
